﻿// App.cpp : Defines the entry point for the application.
//
#include "stdafx.h"
#include "NFontWindow.h"	
#include "../../DuiLib/ucslib.h"
#define N_DEFAULT_FONT_SIZE 15 

//TODO: add these to DuiDefine.h ?

const TCHAR* const kOkButtonControlName = _T("btnok");
const TCHAR* const kCancelButtonControlName = _T("btncancel");
const TCHAR* const kButtonFontSizeControlName = _T("btn_font_size");
const TCHAR* const kButtonFontTypeControlName = _T("btn_font_type");
const TCHAR* const kButtonFontColorControlName = _T("btn_font_color");

const TCHAR* const kButtonFontLeftControlName = _T("btnleft");
const TCHAR* const kButtonFontRightControlName = _T("btnright");
const TCHAR* const kButtonFontBoldControlName = _T("boldbtn");
const TCHAR* const kButtonFontiTabControlName = _T("itabtn");
const TCHAR* const kButtonFontUnderLineControlName = _T("underlinebtn");
const TCHAR* const kButtonFontStikeControlName = _T("strikebtn");


DUI_BEGIN_MESSAGE_MAP(CNFontWnd, WindowImplBase, FALSE)
    //DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
    DUI_ON_CLICK_CTRNAME(kCloseButtonControlName, _OnNotifyCloseBtnClick)
    DUI_ON_CLICK_CTRNAME(kOkButtonControlName, _OnNotifyBtnOkClick)
    DUI_ON_CLICK_CTRNAME(kCancelButtonControlName, _OnNotifyBtnCancelClick)
    DUI_ON_CLICK_CTRNAME(kButtonFontSizeControlName, _OnNotifyBtnFontSizeClick)
    DUI_ON_CLICK_CTRNAME(kButtonFontTypeControlName, _OnNotifyBtnFontType)
    DUI_ON_CLICK_CTRNAME(kButtonFontColorControlName, _OnNotifyBtnFontColorClick)

    //font property
    DUI_ON_CLICK_CTRNAME(kButtonFontLeftControlName, _OnNotifyBtnPropertyClick)
    DUI_ON_CLICK_CTRNAME(kButtonFontRightControlName, _OnNotifyBtnPropertyClick)
    DUI_ON_CLICK_CTRNAME(kButtonFontBoldControlName, _OnNotifyBtnPropertyClick)
    DUI_ON_CLICK_CTRNAME(kButtonFontiTabControlName, _OnNotifyBtnPropertyClick)
    DUI_ON_CLICK_CTRNAME(kButtonFontUnderLineControlName, _OnNotifyBtnPropertyClick)
    DUI_ON_CLICK_CTRNAME(kButtonFontStikeControlName, _OnNotifyBtnPropertyClick)

    DUI_ON_MSGTYPE(DUI_MSGTYPE_FONT_COLOR_SELECTED, _OnNotifyColorSelected)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_FONT_SIZE_SELECTED, _OnNotifySizeSelected)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_FONT_FACE_SELECTED, _OnNotifyFaceSelected)
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CNFontWnd)
DUI_END_CUSTOM_MSG_MAP()

int CNFontWnd::m_size[] = {8, 9, 10, 11, 12, 14,15, 16, 18, 20, 22, 24, 26, 28, 36,-1};

DWORD CNFontWnd::ms_pColors[] =
{
	0xFF<<24 | RGB( 0, 0, 0 ),
	0xFF<<24 | RGB( 144, 51, 0 ),
	0xFF<<24 | RGB( 51, 51, 0 ),
	0xFF<<24 | RGB( 0, 51, 0 ),
	0xFF<<24 | RGB( 0, 51, 102 ),

	0xFF<<24 | RGB( 0, 0, 128 ),
	0xFF<<24 | RGB( 51, 51, 144 ),
	0xFF<<24 | RGB( 64, 64, 64 ),
	0xFF<<24 | RGB( 128, 0, 0 ),
	0xFF<<24 | RGB( 255,  102,0 ),

	0xFF<<24 | RGB( 128,128,0 ),
	0xFF<<24 | RGB( 0, 128, 0 ),
	0xFF<<24 | RGB( 0, 128, 128 ),
	0xFF<<24 | RGB( 0, 0, 255 ),
	0xFF<<24 | RGB( 102, 102, 144 ),
	0xFF<<24 | RGB( 128, 128, 128 ),
	0xFF<<24 | RGB( 255, 0, 0 ),
	0xFF<<24 | RGB( 255, 144, 144 ), 
	0xFF<<24 | RGB( 144, 204, 0 ),
	0xFF<<24 | RGB( 51, 144, 102 ), 
	0xFF<<24 | RGB( 51, 204, 204 ),
	0xFF<<24 | RGB( 51, 102, 255 ), 
	0xFF<<24 | RGB( 128, 0, 128 ),
	0xFF<<24 | RGB( 144, 144, 144 ), 
	0xFF<<24 | RGB( 255, 0, 255 ),
    0x00<<24 | RGB( 255, 0, 255 )

};

CNFontWnd::CNFontWnd( CHARFORMAT2 charFormatInfo, CWnd* parentWnd )
{
    m_pFaceDropWnd = NULL;
    m_pSizeDropWnd = NULL;
    m_pBtnFace = NULL;
    m_pBtnSize = NULL;
    m_pBtnColor = NULL;
    m_pBtnLine0 = NULL;
    m_pBtnLine1 = NULL;
    m_pBtnLine2 = NULL;
    m_pBtnBold = NULL;
    m_pBtnIta = NULL;
    m_pBtnUnderline = NULL;
    m_pBtnStrike = NULL;
    m_pBtnOk = NULL;
    m_pBtnCancel = NULL;
    m_pLabelTitle = NULL;
    m_pSampleText = NULL;

	m_cf = charFormatInfo;
	m_pParentChatWnd = parentWnd;
	m_vecface.clear();
	m_FaceSelIndex = -1;
	m_SizeSelIndex = -1;
	m_ColorSelIndex = -1;
	m_childCreate = false;
	AddFont(GetDefaultFontFaceName(),9);
	AddFont(GetDefaultFontFaceName(),10);
	AddFont(GetDefaultFontFaceName(),12);
	AddFont(GetDefaultFontFaceName(),N_DEFAULT_FONT_SIZE);

	//EnumFonts( ::GetDC(m_hWnd), 0, (FONTENUMPROC)FD_EnumFontProc, (LPARAM)this); //Enumerate font
	//EnumFontFamilies(::GetDC(m_hWnd), 0, (FONTENUMPROC)FD_EnumFontProc, (LPARAM)this);

	//BOOL bRet = TRUE;

	Status sts = Gdiplus::Ok;

	//INT nFontFamilyIndex = 0;
	//枚举系统已经安装的所有字体
	Gdiplus::InstalledFontCollection  fonts;
	INT nFontCount = fonts.GetFamilyCount();
	CString str;
	str.Format(_T("nFontCount:%d \n"),nFontCount);
	//OutputDebugString(str);
	sts = fonts.GetLastStatus();
	FTLASSERT(Ok == sts);
	if (nFontCount > 0)
	{
		Gdiplus::FontFamily* pFontFamily = new Gdiplus::FontFamily[nFontCount];
		if (pFontFamily)
		{
			INT nFound = 0;
			Status hr = fonts.GetFamilies(nFontCount, pFontFamily, &nFound);		
			
			str.Format(_T("nFound: %d \n"),nFound);
			OutputDebugString(str);
			if (Ok == hr)
			{
				FTLASSERT(nFound == nFontCount);
				//FTL::CFStringFormater strFormater;

				TCHAR szFamilyName[LF_FACESIZE] = {0};
				for (INT i = 0; i < nFontCount; i++)
				{
					COM_VERIFY(pFontFamily[i].GetFamilyName(szFamilyName));
				

					CDuiString ss;
					ss.Format(_T("%s"),szFamilyName);
				    //NTALK_LOG->Debug(L"szFamilyName: %s",szFamilyName);
					m_vecface.push_back(ss);	
					AddFont(ss);
					
				}
			}
			delete [] pFontFamily;
		}
	}
}

CNFontWnd::~CNFontWnd()
{
    m_PaintManager.RemoveAllFonts();
}

void CNFontWnd::InitWindow() {

	m_pSizeDropWnd = NULL;
	m_pFaceDropWnd = NULL;
	//m_pColorDropWnd = NULL; 

	InitControl();
	SetWindowText(m_hWnd, LoadStringFromResource(IDS_STRING354));
}  


BOOL CALLBACK FD_EnumFontProc (LPLOGFONT lplf, LPTEXTMETRIC lptm, DWORD dwType, LPARAM lpData)	
{
	CNFontWnd *pThis = reinterpret_cast<CNFontWnd*>(lpData);		

	if (lplf->lfFaceName[0] == _T('@'))
		return TRUE;
    
	CDuiString ss;
	ss.Format(_T("%s"),lplf->lfFaceName);
	pThis->m_vecface.push_back(ss);	
	pThis->AddFont(ss);

	return TRUE;
}

void CNFontWnd::AddFont(LPCTSTR pStrFontName, int nSize, bool bBold, bool bUnderline, bool bItalic){

	m_PaintManager.AddFont(pStrFontName,  nSize,  bBold,  bUnderline,  bItalic);
}

int CNFontWnd::GetFontIndex(LPCTSTR pStrFontName, int nSize, bool bBold, bool bUnderline, bool bItalic){

	return m_PaintManager.GetFontIndex(pStrFontName,  nSize,  bBold,  bUnderline,  bItalic);
}

//GetDefaultFontFaceName


int CNFontWnd::FindFaceIndex(CDuiString valueToFind){

	std::vector<CDuiString>::iterator position = std::find(	m_vecface.begin(), m_vecface.end(), valueToFind);
	bool exists = (position != m_vecface.end());
	if (exists)
    {
		return  position - m_vecface.begin();
    }
	else
    {
		return -1;
    }
}
int CNFontWnd::FindSizeIndex(int sizeToFind){

	for (int i=0;i<sizeof(m_size)/sizeof(int); i++)
	{
		if (m_size[i] * 20 == sizeToFind)
		{
           return i;
		}
		if (m_size[i] == -1)
		{
			break;
		}
	}
	return -1;

}
int CNFontWnd::FindColorIndex(COLORREF valueToFind){

	for (int i=0;i<sizeof(ms_pColors)/sizeof(DWORD); i++)
	{
		if (ms_pColors[i] == valueToFind)
		{
			return i;
		}
	}
	return -1;
}

void CNFontWnd::UpdateSampleText(){

    int size = 0;
//	int  updateindex ;
	bool bUnderline = (m_cf.dwEffects&CFE_UNDERLINE)? true:false;
	bool bItalic = (m_cf.dwEffects&CFE_ITALIC)? true:false;
	bool bBold = (m_cf.dwEffects&CFE_BOLD)? true:false;
	bool bStrikeOut = (m_cf.dwEffects&CFE_STRIKEOUT)? true:false;

	if (m_SizeSelIndex > -1)
	{
		size = m_size[m_SizeSelIndex];
	}
	else{
		size = N_DEFAULT_FONT_SIZE;
	}


	RectF rtDraw;
	rtDraw.X = (Gdiplus::REAL)(0);
	rtDraw.Y = (Gdiplus::REAL)(0);
	rtDraw.Width = (Gdiplus::REAL)340;
	rtDraw.Height = (Gdiplus::REAL)51;

	StringFormat format;
	format.SetAlignment(Gdiplus::StringAlignmentCenter);
	GraphicsPath path;
	if (m_FaceSelIndex > -1)
	{
	/*	AddFont(m_vecface[m_FaceSelIndex],size);
		updateindex = GetFontIndex(m_vecface[m_FaceSelIndex],size);*/
		m_pSampleText->SetFont(m_vecface[m_FaceSelIndex], size, bBold,  bUnderline,  bItalic, bStrikeOut);
        
		 FontFamily fontFamily(m_vecface[m_FaceSelIndex]);
		// Gdiplus::Font font(&fontFamily, nFontHeight, style,UnitPixel);
		Status status = path.AddString(LoadStringFromResource(IDS_STRING358), LoadStringFromResource(IDS_STRING358).GetLength(), 
			&fontFamily, Gdiplus::FontStyleRegular, (Gdiplus::REAL)size, rtDraw, &format);
	}
	else{
		/*AddFont(GetDefaultFontFaceName(),size);
        updateindex =  GetFontIndex(GetDefaultFontFaceName(),size);*/
		m_pSampleText->SetFont(GetDefaultFontFaceName(), size, bBold,  bUnderline,  bItalic, bStrikeOut);
		
		 FontFamily fontFamily(GetDefaultFontFaceName());
		 Status status = path.AddString(LoadStringFromResource(IDS_STRING358), LoadStringFromResource(IDS_STRING358).GetLength(), 
			 &fontFamily, Gdiplus::FontStyleRegular| Gdiplus::FontStyleBold, (Gdiplus::REAL)size, rtDraw, &format);

	}	
	//TFontInfo *pFontInfo = m_PaintManager.GetFontInfo(updateindex);
	RectF rcPathBounds;
	path.GetBounds(&rcPathBounds);
	
	int height = rcPathBounds.Height;
    CRect rc(0, 0, 0, 0);
	rc.left = 1;
	rc.right = 1;
	rc.top = (50 - height)/2 - 6;
	rc.bottom = 50;
    m_pSampleText->SetFixedHeight(height);
	m_pSampleText->SetPadding(rc);

	m_pSampleText->SetTextColor(m_cf.crTextColor);
	

    m_pSampleText->SetText(LoadStringFromResource(IDS_STRING358));
	m_pSampleText->ShowCaret(FALSE);
	m_pSampleText->HideSelection(false);
	m_pSampleText->SetEnabled(false);
	//m_PaintManager.RemoveFontAt(updateindex);
}

CControlUI* CNFontWnd::CreateControl(LPCTSTR pstrClass)
{
	CUCDialogBuilder builder;
	CControlUI *pControl = builder.CreateControl(pstrClass);
	if (pControl)
	{
		//m_PaintManager.AttachDialog(pControl);
		return pControl;
	}

	pControl = __super::CreateControl(pstrClass);

	return pControl;
	
}

void CNFontWnd::InitControl()
{
//  	m_PaintManager.Init(m_hWnd);
//  	CDialogBuilder dlgBuilder;
//  	CUSDialogBuilderCallback cb();
//  	CControlUI* pRoot = dlgBuilder.Create(_T("skin.xml"), (UINT)0,  &cb, &m_PaintManager);
// 	ASSERT(pRoot);
// 	m_PaintManager.AttachDialog(pRoot);
// 	m_PaintManager.AddNotifier(this);


	int index;
	CButtonUI* pBtnClose = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("closebtn")));
	if (pBtnClose != NULL)
	{
		pBtnClose->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_7));
	}

	m_pBtnFace=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_type")));


	m_pBtnSize=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_size")));

	//m_pBtnColor=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_color")));

	m_pBtnBold=static_cast<COptionUI*>(m_PaintManager.FindControl(_T("boldbtn")));
	m_pBtnIta=static_cast<COptionUI*>(m_PaintManager.FindControl(_T("itabtn")));
	m_pBtnStrike=static_cast<COptionUI*>(m_PaintManager.FindControl(_T("strikebtn")));
	m_pBtnUnderline=static_cast<COptionUI*>(m_PaintManager.FindControl(_T("underlinebtn")));
    m_pSampleText =static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("sampletext")));

	CString strLabelText;
	CLabelUI* labelFace = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("facelabel")));
	labelFace->SetShowHtml(true);
	strLabelText.Format(_T("%s<x 35>"),LoadStringFromResource(IDS_STRING354));
    labelFace->SetText(strLabelText);

	CLabelUI* labelEffect = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("effectlabel")));
	labelEffect->SetShowHtml(true);
	strLabelText.Format(_T("%s<x 35>"),LoadStringFromResource(IDS_STRING356));
	labelEffect->SetText(strLabelText);
   


	////////////////////////////////////////////////////////
	CLabelUI* labelSize = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("sizelabel")));
	labelSize->SetShowHtml(true);
	strLabelText.Format(_T("%s<x 18>"),LoadStringFromResource(IDS_STRING355));
	labelSize->SetText(strLabelText);


	CLabelUI* labelColor = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("colorlabel")));
	labelColor->SetShowHtml(true);
	strLabelText.Format(_T("%s<x 18>"),LoadStringFromResource(IDS_STRING357));
    labelColor->SetText(strLabelText);

	//m_pSampleText->SetTextColor(0xFF000000);
	CDuiString strSampleText;
    strSampleText.Format(_T("%s"),LoadStringFromResource(IDS_STRING358));
   
    //btn-face,btn-size;
// 	index = GetFontIndex(GetDefaultFontFaceName(),N_DEFAULT_FONT_SIZE);
//     m_pBtnFace->SetFont(index);
// 	m_pBtnSize->SetFont(index);

    //Set title text;
	m_pLabelTitle=static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("wndTitle")));
	index = GetFontIndex(GetDefaultFontFaceName(),12);
	//m_pLabelTitle->SetTextColor(0xFF222222); //Color(255, 34, 34, 34)
	m_pLabelTitle->SetFont(index);
	//m_pLabelTitle->SetShowHtml(true);
	CString strTitle = LoadStringFromResource(IDS_STRING354);
	//strTitle.Format(_T("<x 4>%s"),LoadStringFromResource(IDS_STRING354));
    m_pLabelTitle->SetText(strTitle);

   //btn-ok,btn-cancel;
	m_pBtnOk=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btnok")));
	m_pBtnCancel=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btncancel")));
	index= GetFontIndex(GetDefaultFontFaceName(),12);
	m_pBtnOk->SetFont(index);
	m_pBtnOk->SetText(LoadStringFromResource(IDS_STRING568));

	m_pBtnCancel->SetFont(index);
    m_pBtnCancel->SetText(LoadStringFromResource(IDS_STRING569));


	index= GetFontIndex(GetDefaultFontFaceName(),12);
	m_pBtnFace->SetFont(index);

     m_FaceSelIndex = FindFaceIndex(m_cf.szFaceName);
	 if (m_FaceSelIndex != -1)
	 {
		 m_pBtnFace->SetText(m_vecface[m_FaceSelIndex]);

	 } 
	 else
	 {
		 m_FaceSelIndex = FindFaceIndex(g_defaultFontFaceName);

		 if (m_FaceSelIndex != -1)
			 m_pBtnFace->SetText(m_vecface[m_FaceSelIndex]);
		 else
		 {
			 m_FaceSelIndex = FindFaceIndex(DEFAULT_KOREAN_FONT_NAME_T);
			 if (m_FaceSelIndex != -1)
			 {
				 m_pBtnFace->SetText(m_vecface[m_FaceSelIndex]);
			 }
			 else
			 {
				 //
				 m_FaceSelIndex = FindFaceIndex(DEFAULT_ANYLANGUAGE_FONT_NAME_T);
				 if (m_FaceSelIndex != -1)
				 {
					 m_pBtnFace->SetText(m_vecface[m_FaceSelIndex]);
				 }
				 else
				     m_pBtnFace->SetText(_T(""));
			 }
		 }

	 }

	 m_SizeSelIndex = FindSizeIndex(m_cf.yHeight);
	 CString sizeStr;	 
	 if (m_SizeSelIndex != -1)
	 {
		 sizeStr.Format(_T("%d"),m_size[m_SizeSelIndex]);
		 m_pBtnSize->SetText(sizeStr);

	 } 
	 else
	 {	
		    sizeStr.Format(_T("%d"),N_DEFAULT_FONT_SIZE);
			m_pBtnSize->SetText(sizeStr);
	 }


	 m_ColorSelIndex = FindColorIndex(m_cf.crTextColor);
	 CLabelUI* plabel = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("label_font_color")));	

	 if (m_ColorSelIndex != -1)
	 {
		 plabel->SetBkColor(ms_pColors[m_ColorSelIndex]);
	 } 
	 else
	 {
		 m_ColorSelIndex = FindColorIndex(0xFF000000);
		 if (m_ColorSelIndex != -1)
			 plabel->SetBkColor(ms_pColors[m_ColorSelIndex]);
	 }

	 SetSelectedFontOption(m_pBtnBold,m_cf.dwEffects&CFE_BOLD?TRUE:FALSE);
	 SetSelectedFontOption(m_pBtnIta,m_cf.dwEffects&CFE_ITALIC?TRUE:FALSE);
	 SetSelectedFontOption(m_pBtnUnderline,m_cf.dwEffects&CFE_UNDERLINE?TRUE:FALSE);
	 SetSelectedFontOption(m_pBtnStrike,m_cf.dwEffects&CFE_STRIKEOUT?TRUE:FALSE);


	UpdateSampleText();	
}


CDuiString CNFontWnd::GetFaceName()
{
	CDuiString strFaceName = g_defaultFontFaceName;

	if (m_FaceSelIndex != -1)
	{
      strFaceName = m_vecface[m_FaceSelIndex];
	}
	return strFaceName;
}

void CNFontWnd::OnClose(){
	CWindowWnd::HandleMessage(WM_CLOSE, 0, 0);
	return; 
}

LONG CNFontWnd::GetSize()
{
	LONG lSize = 10 * 20;

	if (m_SizeSelIndex > -1)
	{					
		lSize = m_size[m_SizeSelIndex] * 20;		
	}

	return lSize;
}



void CNFontWnd::UpdateFontData()
{
	m_cf.dwEffects = 0;
	m_cf.dwMask = 0;

	m_cf.dwMask |= CFM_FACE;
	_tcscpy_s(m_cf.szFaceName, _countof(m_cf.szFaceName), GetFaceName());

	m_cf.dwMask |= CFM_SIZE;
	m_cf.yHeight = GetSize();

	m_cf.dwMask |= CFM_COLOR;
	m_cf.crTextColor = (m_ColorSelIndex > -1) ? ms_pColors[m_ColorSelIndex]:0xFF000000;
	m_cf.bCharSet |= HANGUL_CHARSET;

	m_cf.dwMask |= CFM_BOLD;
	m_cf.dwEffects |= (m_pBtnBold->GetTag()) ? CFE_BOLD : 0;

	m_cf.dwMask |= CFM_ITALIC;
	m_cf.dwEffects |= (m_pBtnIta->GetTag()) ? CFE_ITALIC : 0;

	m_cf.dwMask |= CFM_UNDERLINE;
	m_cf.dwEffects |= (m_pBtnUnderline->GetTag()) ? CFE_UNDERLINE : 0;

	m_cf.dwMask |= CFM_STRIKEOUT;
	m_cf.dwEffects |= (m_pBtnStrike->GetTag()) ? CFE_STRIKEOUT : 0;


	m_cf.yOffset = 0;
	UpdateSampleText();
}

void CNFontWnd::SetSelectedFontOption(CButtonUI *pControl,BOOL selected)
{
	TCHAR bk[2][MAX_PATH] = {
		_T("file='btn_text_nor_c.png'"),
		_T("file='btn_text_foc_c.png'")
	};

	TCHAR line[2][MAX_PATH] = {
		_T("file='btn_text_line_foc.png'"),
		_T("file='btn_text_line_nor.png'")
	};

	//create array v by the horizontal layout in file FontWnd.xml
// 	COptionUI* v[] = {
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("btnleft"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("boldbtn"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("line0"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("underlinebtn"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("line1"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("itabtn"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("line2"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("strikebtn"))),
// 		static_cast<COptionUI*>(m_PaintManager.FindControl(_T("btnright")))
// 	};

	LPCTSTR lpszBkImage = selected?bk[1]:bk[0];
	pControl->SetTag(selected);
	
	if (pControl == (CButtonUI*)m_PaintManager.FindControl(_T("btnleft")))
	{
		pControl->SetNormalImage(selected?_T("file='btn_text_foc_l.png'"):_T("file='btn_text_nor_l.png'"));

		CButtonUI * btn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("boldbtn")));
		btn->SetBkImage(lpszBkImage);
		btn->SetNormalImage(selected?_T("file='img_chat_talk_text_icon_bold_foc.png' dest='9,7,19,20'"):_T("file='img_chat_talk_text_icon_bold_nor.png' dest='9,7,19,20'"));
		btn->SetTag(selected);

		CLabelUI *btn2 = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("line0")));
		btn2->SetBkImage(line[selected?0:1]);
	}
	else if (pControl ==(CButtonUI*)m_PaintManager.FindControl(_T("boldbtn")))
	{
		pControl->SetBkImage(lpszBkImage);
		pControl->SetNormalImage(selected?_T("file='img_chat_talk_text_icon_bold_foc.png' dest='9,7,19,20'"):_T("file='img_chat_talk_text_icon_bold_nor.png' dest='9,7,19,20'"));

		CButtonUI * btn = (CButtonUI*)m_PaintManager.FindControl(_T("btnleft"));
		btn->SetTag(selected);
		btn->SetNormalImage(selected?_T("file='btn_text_foc_l.png'"):_T("file='btn_text_nor_l.png'"));

		CLabelUI *btn2 = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("line0")));
		btn2->SetBkImage(line[selected?0:1]);
	}
	else if (pControl ==(CButtonUI*)m_PaintManager.FindControl(_T("underlinebtn")))
	{
		pControl->SetBkImage(lpszBkImage);
		pControl->SetNormalImage(selected?_T("file='img_chat_talk_text_icon_line_foc.png'  dest='9,7,19,20'"):_T("file='img_chat_talk_text_icon_line_nor.png'  dest='9,7,19,20'"));

		CLabelUI * btn = NULL;
		btn = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("line0")));
		btn->SetBkImage(line[selected?0:1]);	

		btn = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("line1")));
		btn->SetBkImage(line[selected?0:1]);	
	}
	else if (pControl ==(CButtonUI*)m_PaintManager.FindControl(_T("itabtn")))
	{
		pControl->SetBkImage(lpszBkImage);
		pControl->SetNormalImage(selected?_T("file='img_chat_talk_text_icon_italic_foc.png'  dest='9,7,19,20'"):_T("file='img_chat_talk_text_icon_italic_nor.png'  dest='9,7,19,20'"));

		CLabelUI * btn = NULL;
		btn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("line1")));
		btn->SetBkImage(line[selected?0:1]);	

		btn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("line2")));
		btn->SetBkImage(line[selected?0:1]);
	}
	else if (pControl ==(CButtonUI*)m_PaintManager.FindControl(_T("strikebtn")))
	{
		pControl->SetBkImage(lpszBkImage);
		pControl->SetNormalImage(selected?_T("file='img_chat_talk_text_icon_centerline_pre.png'  dest='11,7,21,20'"):_T("file='img_chat_talk_text_icon_centerline_nor.png'  dest='11,7,21,20'"));

		CButtonUI * btn = NULL;
		btn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btnright")));
		btn->SetTag(selected);

		btn->SetNormalImage(selected?_T("file='btn_text_foc_r.png'"):_T("file='btn_text_nor_r.png'"));
	}
	else if (pControl ==(CButtonUI*)m_PaintManager.FindControl(_T("btnright")))
	{
		pControl->SetNormalImage(selected?_T("file='btn_text_foc_r.png'"):_T("file='btn_text_nor_r.png'"));

		CButtonUI * btn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("strikebtn")));
		btn->SetTag(selected);
		btn->SetBkImage(lpszBkImage);
		btn->SetTag(selected);

		CLabelUI *btn2 = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("line2")));
		btn2->SetBkImage(line[selected?0:1]);		
	}
}

void CNFontWnd::_OnNotifyCloseBtnClick(TNotifyUI& msg)
{
    ::DestroyWindow(GetHWND());
}

void CNFontWnd::_OnNotifyBtnOkClick(TNotifyUI& msg)
{
    UpdateFontData();
    m_pParentChatWnd->PostMessage(WM_CHAT_FONT_DLG_CLOSED, (WPARAM)IDOK, 0);
    ::DestroyWindow(GetHWND());
}

void CNFontWnd::_OnNotifyBtnCancelClick(TNotifyUI& msg)
{
    ::DestroyWindow(GetHWND());
}

void CNFontWnd::_OnNotifyBtnFontSizeClick(TNotifyUI& msg)
{
    CButtonUI* pBtn=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_size")));
    CRect rcBtnPos = pBtn->GetPos();
    CRect rcWnd(0, 0, 0, 0);
    GetWindowRect(m_hWnd, rcWnd);

    rcWnd.left = rcWnd.left + rcBtnPos.left;
    rcWnd.top = rcWnd.top + rcBtnPos.bottom+1;
    rcWnd.right = rcWnd.left + /*rcBtnPos.Width()*/56;
    rcWnd.bottom =rcWnd.top + 160+2;
    m_childCreate = true;
    if (m_pSizeDropWnd != NULL){
        if(::IsWindow(m_pSizeDropWnd->GetHWND()))
            DestroyWindow(m_pSizeDropWnd->GetHWND());
        SAFE_DELETE(m_pSizeDropWnd);
        m_pSizeDropWnd = NULL;
    }
    if (m_pSizeDropWnd == NULL)
    {
        m_pSizeDropWnd = new CFontSizeDropWnd(this);
        m_pSizeDropWnd->Create(m_hWnd, _T("FontSizeDropWnd"), WS_POPUP, WS_EX_TOOLWINDOW, rcWnd);
    }
    m_pSizeDropWnd->SetClientRect(rcWnd);
    m_pSizeDropWnd->SetSizeList(m_size,m_SizeSelIndex);
}

void CNFontWnd::_OnNotifyBtnFontType(TNotifyUI& msg)
{
    CButtonUI* pBtn=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_type")));
    CRect rcBtnPos = pBtn->GetPos();
    CRect rcWnd(0, 0, 0, 0);
    GetWindowRect(m_hWnd, rcWnd);

    rcWnd.left = rcWnd.left + rcBtnPos.left;
    rcWnd.top = rcWnd.top + rcBtnPos.bottom+1;
    rcWnd.right = rcWnd.left + /*rcBtnPos.Width()*/127;
    rcWnd.bottom =rcWnd.top + 160+2;
    m_childCreate = true;
    /*if (m_pFaceDropWnd != NULL){
	    if(::IsWindow(m_pFaceDropWnd->GetHWND()))
		    DestroyWindow(m_pFaceDropWnd->GetHWND());
	    SAFE_DELETE(m_pFaceDropWnd);
	    m_pFaceDropWnd = NULL;
    }*/
    if (m_pFaceDropWnd == NULL)
    {
	    m_pFaceDropWnd = new CFontFaceDropWnd(this);
	    m_pFaceDropWnd->Create(m_hWnd, _T("FontFaceDropWnd"), WS_POPUP, WS_EX_TOOLWINDOW, rcWnd);
    }
    m_pFaceDropWnd->SetClientRect(rcWnd);
    m_pFaceDropWnd->SetFaceList(m_vecface,m_FaceSelIndex);
}

void CNFontWnd::_OnNotifyBtnFontColorClick(TNotifyUI& msg)
{
	CButtonUI* pBtn=static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_color")));
	CRect rcBtnPos = pBtn->GetPos();

	CRect rcWnd(0, 0, 0, 0);
	GetWindowRect(m_hWnd, rcWnd);

	rcWnd.left = rcWnd.left + rcBtnPos.left;
	rcWnd.top = rcWnd.top + rcBtnPos.bottom+1;
	rcWnd.right = rcWnd.left +/* rcBtnPos.Width()*/56;
	rcWnd.bottom =rcWnd.top + 160+2;
	m_childCreate = true;
	/*if (m_pColorDropWnd == NULL)
	{
		m_pColorDropWnd = new CFontColorDropWnd(this);
		m_pColorDropWnd->Create(m_hWnd, _T("FontColorDropWnd"), WS_POPUP, WS_EX_TOOLWINDOW, rcWnd);
	}
		m_pColorDropWnd->SetClientRect(rcWnd);
	    m_pColorDropWnd->AddColorItems(ms_pColors);		
    */
}

void CNFontWnd::_OnNotifyBtnPropertyClick(TNotifyUI& msg)
{
    COptionUI *pControl = (COptionUI*)msg.pSender;
    SetSelectedFontOption(pControl,!pControl->GetTag());
    UpdateFontData();
}

void CNFontWnd::_OnNotifyColorSelected(TNotifyUI& msg)
{
    int indx=(int)msg.wParam;
    if (indx == -1)
    {
        return;
    }
    m_ColorSelIndex = indx;
    CLabelUI* plabel = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("label_font_color")));	
    plabel->SetBkColor(ms_pColors[indx]);
    UpdateFontData();
}

void CNFontWnd::_OnNotifySizeSelected(TNotifyUI& msg)
{
    int indx=(int)msg.wParam;
    if (indx == -1)
    {
        return;
    }
    m_SizeSelIndex = indx;
    CButtonUI* pBtn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_size")));	
    CDuiString text;
    text.Format(_T("%d"),m_size[indx]);
    pBtn->SetText(text);
    UpdateFontData();
}

void CNFontWnd::_OnNotifyFaceSelected(TNotifyUI& msg)
{
    int indx=(int)msg.wParam;
    if (indx == -1)
    {
        return;
    }
    m_FaceSelIndex = indx;
    CButtonUI* pBtn = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_font_type")));
    CDuiString text = m_vecface[indx];
    pBtn->SetText(text);
    UpdateFontData();
}

LRESULT CNFontWnd::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled){
//	PostQuitMessage(0);
//	Close();
//	OutputDebugString(_T("cnfontWnd::onkillfocus: %d\n"),this);
	if (m_childCreate)
	{
		OutputDebugString(_T("CNFontWnd OnKillFocus! m_childCreate== true!! \n"));

		return 0;
	}
	OutputDebugString(_T("CNFontWnd OnKillFocus! m_childCreate== false!! \n"));

	ShowWindow(false, false);
    return 0;
}

LRESULT CNFontWnd::OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	if (wParam == VK_ESCAPE)
	{
		bHandled = TRUE;
		Close();
	}
	return 0;
}

void CNFontWnd::GetCharFormat(CHARFORMAT2& cf) 
{
	memcpy(&cf, &m_cf, sizeof(CHARFORMAT2));	
}


void CNFontWnd::OnFinalMessage(HWND hWnd)
{	
	//OutputDebugString(_T("CNFontWnd::OnFinalMessage\n"));
	if (m_pSizeDropWnd != NULL){
		if(::IsWindow(m_pSizeDropWnd->GetHWND()))
			DestroyWindow(m_pSizeDropWnd->GetHWND());
		SAFE_DELETE(m_pSizeDropWnd);
	}
	if (m_pFaceDropWnd != NULL){
		if(::IsWindow(m_pFaceDropWnd->GetHWND()))
			DestroyWindow(m_pFaceDropWnd->GetHWND());
		SAFE_DELETE(m_pFaceDropWnd);
	}
}

